unit cmdlin2;

{ command-line unit - Delphi compatible }

interface

uses misc;

function param_text(c:char):string;
function is_param(c:char):boolean;
function param_int(c:char):longint;
function is_lparam(c:string):boolean;


implementation

function rtr(s:string):string;
var      i:integer;
         first,dontwrite:boolean;
begin
 dontwrite:=true;
 first:=false;
 for i := length(s) downto 1 do begin
  if (s[i]=' ') then dontwrite:=false;
  if not (s[i]=' ') then first:=true;
  if (s[i]=#00) then first:=false;
  if (s[i]=#00) then dontwrite:=false;
   if dontwrite=false then begin
    dontwrite:=true;
    if first=false then delete(s,i,1);
   end;
 end;
rtr:=s;
end;

function is_param(c:char):boolean;
var
 params,ts:string;
 i:integer;
 found:boolean;

begin
 ts:='';
 params:='';
 found:=false;

 for i:= 1 to paramcount do params:=params+' '+paramstr(i);
 i:=0;
 repeat
  inc(i);
  if ((params[i]='-') or (params[i]='/'))  and (params[i-1]=' ')then begin
   if upcase(params[i+1])=upcase(c) then found:=true;
  end;
 until (i>=length(params)) or found;
 is_param:=found;
end;

function is_lparam(c:string):boolean;
var
 s:string;
 tb:boolean;
begin
 tb:=false;
 s:=c;
 if (is_param(c[1])) then begin
  if (is_param(c[1])) and (length(c)>1) then begin
   delete(s,1,1);
   if s=param_text(c[1]) then tb:=true;
  end else begin
{$IFNDEF ver70} if (param_text(c[1])='') or (param_text(c[1])[1]=' ') then tb:=true; {$ENDIF}
{$IFDEF ver70} if (param_text(c[1])='') or (mid(param_text(c[1]),1,1)=' ') then tb:=true; {$ENDIF}
  end;
 end;
 is_lparam:=tb;

end;

function param_text(c:char):string;
var
 s,ts:string;
 i:integer;
 found{,scan}:boolean;
 brk:longint;

begin
 ts:='';
 s:='';
 found:=false;
{// scan:=true;}

 for i:= 1 to paramcount do s:=s+' '+paramstr(i);
 s:=s+'        ';

 i:=0;
 brk:=0;
 repeat
  inc(i);
  if s[i]='~' then inc(brk);
  if ((s[i]='-') or (s[i]='/')) and (s[i-1]=' ') then begin
   if (brk mod 2=0) then begin
    if upcase(s[i+1])=upcase(c) then begin
     found:=true;
     if s[i+2]=' ' then inc(i);
     if not (s[i+2]='-') then begin
      if s[i+2]='~' then begin
       repeat
        ts:=ts+s[i+3];
        inc(i);
       until (s[i+2]='~') or (i>=length(s));
       if ts[length(ts)]='~' then delete(ts,length(ts),1);
      end else begin
       repeat
        ts:=ts+s[i+2];
        inc(i);
       until (s[i+2]=' ') or (i>=length(s));
      end;
     end;
    end;
   end;
  end;
 until (i>=length(s)) or found;
 param_text:=rtr(ts);
end;


function param_int(c:char):longint;
var tl:longint;code:integer;
begin
 val(param_text(c),tl,code);
 if code<>0 then param_int:=0
 else param_int:=tl;
end;


end.