unit misc;

{ misc functions unit - Delphi compatible }

interface

{$IFNDEF ver70} uses SysUtils; {$endif}

procedure StrToArrayCopy(var a:array of char;s:pchar;size:longint);
function mid(line:string;index,len:integer):string;
function PathOnly(s:string):string;
function ltrim(s:string):string;
function rtrim(s:string):string;
function setlen(s:string;len:longint):string;
function setrlen(s:string;rlen:longint):string;
function UpCaseStr(S:string):string;

implementation

procedure StrToArrayCopy(var a:array of char;s:pchar;size:longint);
var i:longint;
begin
{$IFNDEF ver70}try {$ENDIF}
 i:=0;
 repeat
  a[i]:=s[i];
  inc(i);
 until (i=sizeof(a)) or {$IFNDEF ver70}(i=length(s));{$ENDIF} {$IFDEF ver70} (i=sizeof(s)) {$endif}
{$IFNDEF ver70}except
 StrLCopy(a,s,sizeof(a));
end; {$ENDIF}
end;


{
function mid(line:string;index,len:integer):string;
var i:integer;
    tline:string;

begin
tline:=line;
if length(tline)>len then begin
 delete(tline,index+len,length(line));
 for i:= 1 to index-1 do delete(line,1,1);
end;

mid:=tline;

end;
}

function mid(line:string;index,len:integer):string;
var
 ts:string;
 i:longint;

begin
 ts:='';
 if length(line)>len+index-1 then begin
  for i:= index to len+index-1 do begin
   ts:=ts+line[i];
  end;
 end else begin
  ts:=line;
  delete(ts,1,index-1);
 end;
 mid:=ts;
end;


function PathOnly(s:string):string;
var i:longint;
    ts:string;
begin
 ts:=s;
 i:=length(ts);
 if (pos('\',ts)<>0) then begin
  repeat
   dec(i);
  until (ts[i]='\') or (i=1);
  if not (ts[length(ts)]='\') then ts:=ts+'\';
  delete(ts,i,length(ts)-1);
  if not (ts[length(ts)]='\') then ts:=ts+'\';
 end else ts:='';
 PathOnly:=ts;
end;

function rtrim(s:string):string;
var
  ts:string;
  i:longint;
begin
  ts:='';
  if length(s)>1 then begin
   ts:=s;
   i:=length(s)-1;
   while (ts[i]=' ') or (ts[i]=#00) do begin
    delete(ts,i,1);
    dec(i);
   end;
  end;
  {$IFNDEF ver70}try{$ENDIF}
  if ((ts[length(ts)]=#0) or (ts[length(ts)]=' ')) then delete(ts,length(ts),1);
  {$IFNDEF ver70}except end;{$ENDIF}
  rtrim:=ts;
end;

function ltrim(s:string):string;
var
  ts:string;
  i:longint;
begin
  ts:='';
  if length(s)>2 then begin
   ts:=s;
   i:=1;
   while (ts[i]=' ') or (ts[i]=#00) do begin
    delete(ts,i,1);
    inc(i);
   end;
  end;
  if ts[1]=' ' then delete(ts,1,1);
  ltrim:=ts;
end;

function setlen(s:string;len:longint):string;
var
ts:string;
i:longint;
begin
ts:=s;

if length(s)>=len then ts:=mid(s,1,len)
else
for i:= length(s) to len do  ts:=ts+' ';

setlen:=ts;
end;

function setrlen(s:string;rlen:longint):string;
var
ts:string;
i:longint;

begin
ts:=s;
if length(s)>=rlen then ts:=mid(s,1,rlen)
else
for i:= length(s) to rlen do ts:=' '+ts;
setrlen:=ts;
end;

function UpCaseStr(S:string):string;
var i:longint;
    ts:string;
begin
 ts:=s;
 for i:=1 to length(ts) do ts[i]:=upcase(ts[i]);
 UpCaseStr:=ts;
end;

end.



