program ptpost;

{

todo: multiple files;

}

uses
  sysutils , {shellapi,} windows,
  cmdlin2 in 'Cmdlin2.pas',
  misc in 'Misc.pas',
  ctlunit3 in 'Ctlunit3.pas',
  ctlunit in 'Ctlunit.pas';


const cpr='PtPost v1.01.W32 (c) 1998 Ryoga Hibiki';
      cf:string=#$0d+#$0a;

var   f:text;

      ctlname,dir,fname,exename,
      subj,areatag,sourcename,sourceaddress,
      targetname,targetaddress,flags:string;

      startupinfo:TStartupInfo;
      processinfo:TProcessInformation;

      WaitValue,ExitCode:longint;

begin
 writeln(cf,cpr,cf);

 if paramcount<1 then begin
  writeln(' Usage: '+cf+cf+
          ' ptpost <filename> [switches]'+cf+cf+
          ' Switches:'+cf+cf+
          ' -a - areatag'+cf+
          ' -b - subj'+cf+
          ' -l - flags'+cf+
          ' -f - source name'+cf+
          ' -s - source address'+cf+
          ' -t - target name'+cf+
          ' -d - target address'+cf+cf+
          ' -k - kill file after posting'+cf+cf+
          ' Notes:'+cf+cf+
          ' # full path required for filename'+cf+
          ' # control file must exist in program directory'+cf+
          ' # anime and parma tosser rule! :)');
          halt;
 end else begin
  writeln(' # checking configuration...');
  dir:=GetCtl('PtPath',pathonly(paramstr(0))+'ptpost.ctl','');
  if dir='' then begin writeln(' ! configuration file error..');halt;end;

  ctlname:=pathonly(paramstr(0))+'ptpost.ctl';

  writeln(' # reading defaults...');

  exename:=GetCtl('PtExe',ctlname,'');

  if not is_param('a') then areatag:=GetCtl('DefAreaTag',ctlname,'')
  else areatag:=param_text('a');

  if not is_param('b') then subj:=GetCtl('DefSubj',ctlname,'')
  else subj:=param_text('b');

  if not is_param('l') then flags:=GetCtl('DefFlags',ctlname,'')
  else flags:=param_text('l');

  if not is_param('f') then sourcename:=GetCtl('DefSourceName',ctlname,'')
  else sourcename:=param_text('f');

  if not is_param('s') then sourceaddress:=GetCtl('DefSourceAddr',ctlname,'')
  else sourceaddress:=param_text('s');

  if not is_param('t') then targetname:=GetCtl('DefTargetName',ctlname,'')
  else targetname:=param_text('t');

  if not is_param('d') then targetaddress:=GetCtl('DefTargetAddr',ctlname,'')
  else targetaddress:=param_text('d');

  writeln(' # searching filename: ',paramstr(1));
  if fileexists(paramstr(1)) then begin
   writeln(' # checking parma tosser folder.. ('+dir+')');
   if not (dir[length(dir)]='\') then dir:=dir+'\';
   if fileexists (dir+'partoss.cfg') then begin
    writeln(' # reading parma tosser configuration..');
    fname:=GetCtl('PostingFile',dir+'partoss.cfg','');
    if pathonly(fname)='' then fname:=dir+fname;
    writeln(' # posting file: '+fname);
     if copyfile(pchar(fname),pchar(dir+'partoss.ps$'),true) then begin
      writeln(' # saving old posting file..');
      assign(f,fname);

      rewrite(f);
{
      writeln(f,'When Daily');
      writeln(f,'Area ',param_text('a'));
      writeln(f,'From "',param_text('f')+'" '+param_text('s'));
      writeln(f,'To   "',param_text('t')+'" '+param_text('d'));
      writeln(f,'Subj '+param_text('b'));
      writeln(f,'Flags ',param_text('l'));
      writeln(f,'Text '+paramstr(1));
}

     writeln(f,'When Daily');
     writeln(f,'Area  ',areatag);
     writeln(f,'From  "',sourcename+'" '+sourceaddress);
     writeln(f,'To    "',targetname+'" '+targetaddress);
     writeln(f,'Subj  '+subj);
     writeln(f,'Flags ',flags);
     writeln(f,'Text  '+paramstr(1));

     close(f);

     FillChar(StartupInfo,Sizeof(StartupInfo),0);
     StartupInfo.wShowWindow:=SW_SHOW;
     StartupInfo.dwFlags:=STARTF_USESHOWWINDOW;
     StartupInfo.cb := Sizeof(StartupInfo);

     writeln(' # executing partoss (detached console)...');

     CreateProcess(pchar(dir+exename),' postF',nil,nil,False,
              DETACHED_PROCESS or NORMAL_PRIORITY_CLASS,
              nil,pchar(dir),StartupInfo,ProcessInfo);

     writeln(' # waiting for partoss to finish...');

     WaitValue:=WaitForSingleObject(ProcessInfo.hProcess,12000);

     if WaitValue=WAIT_TIMEOUT then begin
      writeln(' % timeout - terminating process..');
      GetExitCodeProcess(ProcessInfo.hProcess,ExitCode);
      TerminateProcess(ProcessInfo.hProcess,ExitCode);
     end;

     writeln(' # restoring old posting file...');
     MoveFileEx(pchar(dir+'partoss.ps$'),pchar(fname),MOVEFILE_REPLACE_EXISTING);

      if is_param('k') then begin
       writeln(' # erasing: ',fname);
       assign(f,fname);
       Erase(f);
      end;
     end {copy ok} else begin
     writeln(' % temp file already exists..');
    end; {copy failed}
   end;
  end; {filefound}
 end; {params_found}
 writeln(' # finished.');
end.
