unit ctlunit3;

{ control file universal handling unit v3 }
{ borland delphi 3.0 / bp7 compatible     }
{ (c) 1998 Ryoga Hibiki, ryoga@chat.ru    }


interface

function GetCtl(key,ctl,defvalue:string):string;
function GetCtlStr(key,ctl,defvalue:string):string;
function GetCtlInt(key,ctl,defvalue:string):longint;
function GetCtlBool(key,ctl:string;defvalue:boolean):boolean;

implementation

function StrUp(s:string):string;
var i:longint;
    ts:string;
begin
 ts:='';
 for i:= 1 to length(s) do ts:=ts+upcase(s[i]);
 StrUp:=ts;
end;

function str2int(s:string):longint;
var code:integer;
    i:longint;

begin
 val(s,i,code);
 str2int:=i;
end;

function GetCtl(key,ctl,defvalue:string):string;
var f:text;
    s:string;
    tkey,tval:string;
    i:longint;
    found:boolean;

begin
 found:=false;
 assign(f,ctl);
 {$I-} reset(f); {$I+}
 if IOResult=0 then begin
  repeat
   readln(f,s);
   if (length(s)>1) and not (s[1]=';') then begin
    i:=0;tkey:='';tval:='';
    repeat
     inc(i);
     tkey:=tkey+s[i];
    until (s[i]=' ') or (i=length(s)-1);
    if tkey[length(tkey)]=' ' then delete(tkey,length(tkey),1);
    repeat
     inc(i);
    until not (s[i]=' ') or (i=length(s)-1);
     dec(i,2);
    if strup(tkey)=strup(key) then begin
     found:=true;
     if s[i]='"' then begin
      repeat
       inc(i);
       tval:=tval+s[i+1];
      until (s[i+2]='"') or (i+1=length(s));
     end {"}
     else begin
      repeat
       inc(i);
       tval:=tval+s[i+1];
      until (i+1=length(s)) or (s[i+2]=';');
     end; {no brackets}
   end;
  end; {len_check}
  until eof(f) or found;
  close(f);
 end; {io}
 if not found then tval:=defvalue;
 GetCtl:=tval;
end;

function GetCtlStr(key,ctl,defvalue:string):string;
var s:string;
begin
 s:=GetCtl(key,ctl,defvalue);
 if s='' then s:=defvalue;
 GetCtlStr:=s;

end;

function GetCtlInt(key,ctl,defvalue:string):longint;
begin
 getctlint:=str2int(GetCtl(key,ctl,defvalue));
end;

function GetCtlBool(key,ctl:string;defvalue:boolean):boolean;
var ts:string;
begin
 ts:=GetCtl(key,ctl,'');
 if strup(ts)='YES' then getctlbool:=true
 else if strup(ts)='NO' then getctlbool:=false
 else GetCtlbool:=defvalue;
end;


begin
end.
